/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumAccesslevel;
import de.ship.db.tables.records.VCoreUserprivilegeRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreUserprivilege extends TableImpl<VCoreUserprivilegeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_userprivilege</code>
     */
    public static final VCoreUserprivilege V_CORE_USERPRIVILEGE = new VCoreUserprivilege();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreUserprivilegeRecord> getRecordType() {
        return VCoreUserprivilegeRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_userprivilege.forename</code>.
     */
    public final TableField<VCoreUserprivilegeRecord, String> FORENAME = createField(DSL.name("forename"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_userprivilege.surname</code>.
     */
    public final TableField<VCoreUserprivilegeRecord, String> SURNAME = createField(DSL.name("surname"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_userprivilege.username</code>.
     */
    public final TableField<VCoreUserprivilegeRecord, String> USERNAME = createField(DSL.name("username"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_userprivilege.usnr</code>.
     */
    public final TableField<VCoreUserprivilegeRecord, Integer> USNR = createField(DSL.name("usnr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_userprivilege.privilege_name</code>.
     */
    public final TableField<VCoreUserprivilegeRecord, String> PRIVILEGE_NAME = createField(DSL.name("privilege_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_userprivilege.fk_privilege</code>.
     */
    public final TableField<VCoreUserprivilegeRecord, Integer> FK_PRIVILEGE = createField(DSL.name("fk_privilege"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_userprivilege.shipdesigner_acl</code>.
     */
    public final TableField<VCoreUserprivilegeRecord, EnumAccesslevel> SHIPDESIGNER_ACL = createField(DSL.name("shipdesigner_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    /**
     * The column <code>common_dd.v_core_userprivilege.shippie_acl</code>.
     */
    public final TableField<VCoreUserprivilegeRecord, EnumAccesslevel> SHIPPIE_ACL = createField(DSL.name("shippie_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    /**
     * The column <code>common_dd.v_core_userprivilege.square_acl</code>.
     */
    public final TableField<VCoreUserprivilegeRecord, EnumAccesslevel> SQUARE_ACL = createField(DSL.name("square_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    private VCoreUserprivilege(Name alias, Table<VCoreUserprivilegeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreUserprivilege(Name alias, Table<VCoreUserprivilegeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_userprivilege" as  SELECT t_core_person.forename,
         t_core_person.surname,
         t_core_person.username,
         t_core_person.usnr,
         t_core_privilege.name AS privilege_name,
         t_core_privilege.pk AS fk_privilege,
         t_core_userprivilege.shipdesigner_acl,
         t_core_userprivilege.shippie_acl,
         t_core_userprivilege.square_acl
        FROM ((common_dd.t_core_person
          LEFT JOIN common_dd.t_core_userprivilege ON ((t_core_userprivilege.fk_usnr = t_core_person.usnr)))
          JOIN common_dd.t_core_privilege ON ((t_core_userprivilege.fk_privilege = t_core_privilege.pk)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_userprivilege</code> table
     * reference
     */
    public VCoreUserprivilege(String alias) {
        this(DSL.name(alias), V_CORE_USERPRIVILEGE);
    }

    /**
     * Create an aliased <code>common_dd.v_core_userprivilege</code> table
     * reference
     */
    public VCoreUserprivilege(Name alias) {
        this(alias, V_CORE_USERPRIVILEGE);
    }

    /**
     * Create a <code>common_dd.v_core_userprivilege</code> table reference
     */
    public VCoreUserprivilege() {
        this(DSL.name("v_core_userprivilege"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreUserprivilege as(String alias) {
        return new VCoreUserprivilege(DSL.name(alias), this);
    }

    @Override
    public VCoreUserprivilege as(Name alias) {
        return new VCoreUserprivilege(alias, this);
    }

    @Override
    public VCoreUserprivilege as(Table<?> alias) {
        return new VCoreUserprivilege(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUserprivilege rename(String name) {
        return new VCoreUserprivilege(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUserprivilege rename(Name name) {
        return new VCoreUserprivilege(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUserprivilege rename(Table<?> name) {
        return new VCoreUserprivilege(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUserprivilege where(Condition condition) {
        return new VCoreUserprivilege(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUserprivilege where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUserprivilege where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUserprivilege where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUserprivilege where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUserprivilege where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUserprivilege where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUserprivilege where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUserprivilege whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUserprivilege whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
